'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.normalizeLanguage = exports.SUPPORTED_LANGUAGES = undefined;

var _freeze = require('babel-runtime/core-js/object/freeze');

var _freeze2 = _interopRequireDefault(_freeze);

var _light = require('react-syntax-highlighter/light');

var _memoizeOne = require('memoize-one');

var _memoizeOne2 = _interopRequireDefault(_memoizeOne);

var _clojure = require('react-syntax-highlighter/languages/hljs/clojure');

var _clojure2 = _interopRequireDefault(_clojure);

var _coffeescript = require('react-syntax-highlighter/languages/hljs/coffeescript');

var _coffeescript2 = _interopRequireDefault(_coffeescript);

var _cpp = require('react-syntax-highlighter/languages/hljs/cpp');

var _cpp2 = _interopRequireDefault(_cpp);

var _cs = require('react-syntax-highlighter/languages/hljs/cs');

var _cs2 = _interopRequireDefault(_cs);

var _css = require('react-syntax-highlighter/languages/hljs/css');

var _css2 = _interopRequireDefault(_css);

var _d = require('react-syntax-highlighter/languages/hljs/d');

var _d2 = _interopRequireDefault(_d);

var _go = require('react-syntax-highlighter/languages/hljs/go');

var _go2 = _interopRequireDefault(_go);

var _groovy = require('react-syntax-highlighter/languages/hljs/groovy');

var _groovy2 = _interopRequireDefault(_groovy);

var _java = require('react-syntax-highlighter/languages/hljs/java');

var _java2 = _interopRequireDefault(_java);

var _javascript = require('react-syntax-highlighter/languages/hljs/javascript');

var _javascript2 = _interopRequireDefault(_javascript);

var _kotlin = require('react-syntax-highlighter/languages/hljs/kotlin');

var _kotlin2 = _interopRequireDefault(_kotlin);

var _lua = require('react-syntax-highlighter/languages/hljs/lua');

var _lua2 = _interopRequireDefault(_lua);

var _objectivec = require('react-syntax-highlighter/languages/hljs/objectivec');

var _objectivec2 = _interopRequireDefault(_objectivec);

var _php = require('react-syntax-highlighter/languages/hljs/php');

var _php2 = _interopRequireDefault(_php);

var _python = require('react-syntax-highlighter/languages/hljs/python');

var _python2 = _interopRequireDefault(_python);

var _ruby = require('react-syntax-highlighter/languages/hljs/ruby');

var _ruby2 = _interopRequireDefault(_ruby);

var _rust = require('react-syntax-highlighter/languages/hljs/rust');

var _rust2 = _interopRequireDefault(_rust);

var _scala = require('react-syntax-highlighter/languages/hljs/scala');

var _scala2 = _interopRequireDefault(_scala);

var _shell = require('react-syntax-highlighter/languages/hljs/shell');

var _shell2 = _interopRequireDefault(_shell);

var _sql = require('react-syntax-highlighter/languages/hljs/sql');

var _sql2 = _interopRequireDefault(_sql);

var _swift = require('react-syntax-highlighter/languages/hljs/swift');

var _swift2 = _interopRequireDefault(_swift);

var _typescript = require('react-syntax-highlighter/languages/hljs/typescript');

var _typescript2 = _interopRequireDefault(_typescript);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * These are those languages which will be pre-loaded to auto-detect
 * the language for syntax highlighting. This list is based on the top 20
 * languages on github by number of PR, as of May 2018
 * https://madnight.github.io/githut/#/pull_requests/2018/1
 */

/* eslint import/no-dynamic-require: 0, global-require: 0 */
(0, _light.registerLanguage)('clojure', _clojure2.default);
(0, _light.registerLanguage)('coffeescript', _coffeescript2.default);
(0, _light.registerLanguage)('cpp', _cpp2.default);
(0, _light.registerLanguage)('cs', _cs2.default);
(0, _light.registerLanguage)('css', _css2.default);
(0, _light.registerLanguage)('d', _d2.default);
(0, _light.registerLanguage)('go', _go2.default);
(0, _light.registerLanguage)('groovy', _groovy2.default);
(0, _light.registerLanguage)('java', _java2.default);
(0, _light.registerLanguage)('javascript', _javascript2.default);
(0, _light.registerLanguage)('kotlin', _kotlin2.default);
(0, _light.registerLanguage)('lua', _lua2.default);
(0, _light.registerLanguage)('objectivec', _objectivec2.default);
(0, _light.registerLanguage)('php', _php2.default);
(0, _light.registerLanguage)('python', _python2.default);
(0, _light.registerLanguage)('ruby', _ruby2.default);
(0, _light.registerLanguage)('rust', _rust2.default);
(0, _light.registerLanguage)('scala', _scala2.default);
(0, _light.registerLanguage)('shell', _shell2.default);
(0, _light.registerLanguage)('sql', _sql2.default);
(0, _light.registerLanguage)('swift', _swift2.default);
(0, _light.registerLanguage)('typescript', _typescript2.default);

/*
 * These values all those are supported by ADF.
 * The comments show mappings of these values to the corresponding
 * language definition file, or to that of the most
 * syntactically similar language supported by highlightjs
 */
var SUPPORTED_LANGUAGES = exports.SUPPORTED_LANGUAGES = (0, _freeze2.default)([{
  name: 'PHP',
  alias: ['php', 'php3', 'php4', 'php5'],
  value: 'php'
}, {
  name: 'Java',
  alias: ['java'],
  value: 'java'
}, {
  name: 'CSharp',
  alias: ['csharp', 'c#'],
  value: 'cs'
}, {
  name: 'Python',
  alias: ['python', 'py'],
  value: 'python'
}, {
  name: 'JavaScript',
  alias: ['javascript', 'js'],
  value: 'javascript'
}, {
  name: 'Html',
  alias: ['html'],
  value: 'xml'
}, {
  name: 'C++',
  alias: ['c++', 'cpp'],
  value: 'cpp'
}, {
  name: 'Ruby',
  alias: ['ruby', 'rb', 'duby'],
  value: 'ruby'
}, {
  name: 'Objective-C',
  alias: ['objective-c', 'objectivec', 'obj-c', 'objc'],
  value: 'objectivec'
}, {
  name: 'C',
  alias: ['c'],
  value: 'cpp'
}, {
  name: 'Swift',
  alias: ['swift'],
  value: 'swift'
}, {
  name: 'TeX',
  alias: ['tex', 'latex'],
  value: 'tex'
}, {
  name: 'Shell',
  alias: ['shell', 'bash', 'sh', 'ksh', 'zsh'],
  value: 'shell'
}, {
  name: 'Scala',
  alias: ['scala'],
  value: 'scala'
}, {
  name: 'Go',
  alias: ['go'],
  value: 'go'
}, {
  name: 'ActionScript',
  alias: ['actionscript', 'actionscript3', 'as'],
  value: 'actionscript'
}, {
  name: 'ColdFusion',
  alias: ['coldfusion'],
  value: 'xml'
}, {
  name: 'JavaFX',
  alias: ['javafx', 'jfx'],
  value: 'java'
}, {
  name: 'VbNet',
  alias: ['vbnet', 'vb.net'],
  value: 'vbnet'
}, {
  name: 'JSON',
  alias: ['json'],
  value: 'json'
}, {
  name: 'MATLAB',
  alias: ['matlab'],
  value: 'matlab'
}, {
  name: 'Groovy',
  alias: ['groovy'],
  value: 'groovy'
}, {
  name: 'SQL',
  alias: ['sql', 'postgresql', 'postgres', 'plpgsql', 'psql', 'postgresql-console', 'postgres-console', 'tsql', 't-sql', 'mysql', 'sqlite'],
  value: 'sql'
}, {
  name: 'R',
  alias: ['r'],
  value: 'r'
}, {
  name: 'Perl',
  alias: ['perl', 'pl'],
  value: 'perl'
}, {
  name: 'Lua',
  alias: ['lua'],
  value: 'lua'
}, {
  name: 'Delphi',
  alias: ['delphi', 'pas', 'pascal', 'objectpascal'],
  value: 'delphi'
}, {
  name: 'XML',
  alias: ['xml'],
  value: 'xml'
}, {
  name: 'TypeScript',
  alias: ['typescript', 'ts'],
  value: 'typescript'
}, {
  name: 'CoffeeScript',
  alias: ['coffeescript', 'coffee-script', 'coffee'],
  value: 'coffeescript'
}, {
  name: 'Clojure',
  alias: ['clojure', 'clj'],
  value: 'clojure'
}, {
  name: 'Haskell',
  alias: ['haskell', 'hs'],
  value: 'haskell'
}, {
  name: 'Puppet',
  alias: ['puppet'],
  value: 'puppet'
}, {
  name: 'Arduino',
  alias: ['arduino'],
  value: 'arduino'
}, {
  name: 'Fortran',
  alias: ['fortran'],
  value: 'fortran'
}, {
  name: 'Erlang',
  alias: ['erlang', 'erl'],
  value: 'erlang'
}, {
  name: 'PowerShell',
  alias: ['powershell', 'posh', 'ps1', 'psm1'],
  value: 'powershell'
}, {
  name: 'Haxe',
  alias: ['haxe', 'hx', 'hxsl'],
  value: 'haxe'
}, {
  name: 'Elixir',
  alias: ['elixir', 'ex', 'exs'],
  value: 'elixir'
}, {
  name: 'Verilog',
  alias: ['verilog', 'v'],
  value: 'verilog'
}, {
  name: 'Rust',
  alias: ['rust'],
  value: 'rust'
}, {
  name: 'VHDL',
  alias: ['vhdl'],
  value: 'vhdl'
}, {
  name: 'Sass',
  alias: ['sass'],
  value: 'less'
}, {
  name: 'OCaml',
  alias: ['ocaml'],
  value: 'ocaml'
}, {
  name: 'Dart',
  alias: ['dart'],
  value: 'dart'
}, {
  name: 'CSS',
  alias: ['css'],
  value: 'css'
}, {
  name: 'reStructuredText',
  alias: ['restructuredtext', 'rst', 'rest'],
  value: 'rest'
}, {
  name: 'ObjectPascal',
  alias: ['objectpascal'],
  value: 'delphi'
}, {
  name: 'Kotlin',
  alias: ['kotlin'],
  value: 'kotlin'
}, {
  name: 'D',
  alias: ['d'],
  value: 'd'
}, {
  name: 'Octave',
  alias: ['octave'],
  value: 'matlab'
}, {
  name: 'QML',
  alias: ['qbs', 'qml'],
  value: 'qml'
}, {
  name: 'Prolog',
  alias: ['prolog'],
  value: 'prolog'
}, {
  name: 'FoxPro',
  alias: ['foxpro', 'vfp', 'clipper', 'xbase'],
  value: 'vbnet'
}, {
  name: 'Scheme',
  alias: ['scheme', 'scm'],
  value: 'scheme'
}, {
  name: 'CUDA',
  alias: ['cuda', 'cu'],
  value: 'cpp'
}, {
  name: 'Julia',
  alias: ['julia', 'jl'],
  value: 'julia'
}, {
  name: 'Racket',
  alias: ['racket', 'rkt'],
  value: 'lisp'
}, {
  name: 'Ada',
  alias: ['ada', 'ada95', 'ada2005'],
  value: 'ada'
}, {
  name: 'Tcl',
  alias: ['tcl'],
  value: 'tcl'
}, {
  name: 'Mathematica',
  alias: ['mathematica', 'mma', 'nb'],
  value: 'mathematica'
}, {
  name: 'Autoit',
  alias: ['autoit'],
  value: 'autoit'
}, {
  name: 'StandardML',
  alias: ['standardmL', 'sml', 'standardml'],
  value: 'sml'
}, {
  name: 'Objective-J',
  alias: ['objective-j', 'objectivej', 'obj-j', 'objj'],
  value: 'objectivec'
}, {
  name: 'Smalltalk',
  alias: ['smalltalk', 'squeak', 'st'],
  value: 'smalltalk'
}, {
  name: 'Vala',
  alias: ['vala', 'vapi'],
  value: 'vala'
}, {
  name: 'ABAP',
  alias: ['abap'],
  value: 'sql'
}, {
  name: 'LiveScript',
  alias: ['livescript', 'live-script'],
  value: 'livescript'
}, {
  name: 'XQuery',
  alias: ['xquery', 'xqy', 'xq', 'xql', 'xqm'],
  value: 'xquery'
}, {
  name: 'PlainText',
  alias: ['text', 'plaintext'],
  value: 'text'
}]);

var normalizeLanguage = exports.normalizeLanguage = (0, _memoizeOne2.default)(function (language) {
  if (!language) {
    return '';
  }
  var match = SUPPORTED_LANGUAGES.find(function (val) {
    return val.name === language || val.alias.includes(language);
  });
  // Fallback to plain monospaced text if language passed but not supported
  return match ? match.value : 'text';
});